﻿﻿![Sprint Reader](https://raw.githubusercontent.com/anthonynosek/sprint-reader-chrome/master/src/graphics/icon128.png?raw=true)

# Sprint Reader

<a href="http://tinyurl.com/lggjhxr">**Sprint Reader**</a> is an easy to use (Google Chrome) speed reading extension. 

> Current (stable) version: 2.5.0

Simply select text on a webpage, right-click and select `Sprint read selected text` from the menu. This will launch the reader window, the selected text is displayed word-by-word in a fixed focal position. The duration of each slide is calculated based upon a word-per-minute (WPM) setting.

This method of reading is known as **Rapid Serial Visual Presentation** or RSVP for short. Studies have shown the habit of internally "sounding out" (sub-vocalising) words is a limiting factor which prevents faster reading speeds from being obtained. RSVP eliminates the "sounding out" of words as individual words are not displayed long enough for sub-vocalisation to occur.

RSVP proves that humans can absorb information much faster than standard reading rates with the same level of comprehension.

Key features of Sprint Reader:  
> Multiple colour schemes  
> Optimal letter highlighting  
> Automatic language detection  
> Adjustable font and font size  
> Adjustable word-per-minute (WPM)  
> Intelligent hyphenation of words  
> Focal guides to improve attention  
> Adjustable words-per-slide (chunk size)  
> Provision for different display algorithms  
> Optimal word positioning to improve comprehension  
> Optional grammar delays

## Table of Contents
 
* [Team Members](#team-members)
* [Sprint Reader on Social Media](#social)
* [Getting Started](#getting-started)
* [Useful Resources](#useful-resources)
* [Developers Guide (Wiki)](#developers-guide)
* [License](#license)
 
## <a name="team-members"></a>Team Members
* Anthony Nosek (<anthonynosek@gmail.com>)

## <a name="social"></a>Sprint Reader on Social Media

Sprint Reader has both a ﻿![Google+](https://raw.githubusercontent.com/anthonynosek/sprint-reader-chrome/master/src/graphics/google_plus_16x16.png?raw=true) [ Google+](https://plus.google.com/b/105075625257906831241/105075625257906831241/posts) and ﻿![Facebook](https://raw.githubusercontent.com/anthonynosek/sprint-reader-chrome/master/src/graphics/facebook_16x16.png?raw=true) [ Facebook](https://www.facebook.com/SprintReader) page for the latest developments, interesting articles and updates from the Sprint Reader team. Check back for new tips and suggestions from our sprinters.

## <a name="useful-resources"></a>Useful Resources

- [Google Chrome Extensions Official Site](https://developer.chrome.com/extensions)
- [Google Chrome Extensions Getting Started Guide](https://developer.chrome.com/extensions/getstarted)
- [Google Chrome Extensions Overview](https://developer.chrome.com/extensions/overview)
- [Google Chrome Extensions Developers Guide](https://developer.chrome.com/extensions/devguide)

## <a name="getting-started"></a>Getting Started

We've made it easy for you to write code and develop new features for Sprint Reader. **To start: Download the source code** and load the extension into Google Chrome (Developer mode).

From the official [Google Chrome](https://developer.chrome.com/extensions/getstarted) website:

> Extensions that you download from the Chrome Web Store are packaged up as .crx files, which is great for distribution, but not so great for development. Recognizing this, Chrome gives you a quick way of loading up your working directory for testing. Let's do that now.

> 1. Visit `chrome://extensions` in your browser (or open up the Chrome menu by clicking the icon to the far right of the Omnibox. The menu's icon is three horizontal bars.. and select **Extensions** under the **Tools** menu to get to the same place).
> 2. Ensure that the **Developer mode** checkbox in the top right-hand corner is checked.
> 3. Click **Load unpacked extension…** to pop up a file-selection dialog.
> 4. Navigate to the directory in which your extension files live, and select it.

> Alternatively, you can drag and drop the directory where your extension files live onto `chrome://extensions` in your browser to load it.

> If the extension is valid, it'll be loaded up and active right away! If it's invalid, an error message will be displayed at the top of the page. Correct the error, and try again.

Once you've loaded Sprint Reader into Google Chrome you can begin to edit code and add functionality! _Good luck and keep us updated with what you're planning to add / achieve / fix!_

## <a name="developers-guide"></a>Developers Guide

See the [Wiki](https://github.com/anthonynosek/sprint-reader-chrome/wiki) for full documentation, operational details and other information. You should also consult the [CONTRIBUTING.md](https://github.com/anthonynosek/sprint-reader-chrome/blob/master/CONTRIBUTING.md) file located at the root of the Sprint Reader project.

## <a name="license"></a>License

Copyright (c) 2013-2017, Anthony Nosek  
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
  list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.

* Neither the name of Sprint Reader, Anthony Nosek nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL ANTHONY NOSEK BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
